package listactors
import scala.actors.Actor._


object Main {

  def main(args: Array[String]): Unit = {
    
    
    // Erzeugen von ListCalculations - Objekten zum Testen
    val test1 = new ListCalculations( "Zweier" ,  x => x * 2  )  // angehngte Werte werden verdoppelt
    val test2 = new ListCalculations( "Quadrate" , x => x * x  ) // angehngte Werte werden quadriert
    // TODO: Aufgabe 1 - Erstellen Sie ein drittes Testobjekt, registrieren Sie dieses beim Broadcaster 

    
    // Starten des Broadcasters, registrieren der Test-Objekte
    Broadcaster.start()    
    Broadcaster ! Register (test1)
    Broadcaster ! Register (test2)

    
    // Alle registrierten ListCalculations werden nun mit 10 Werten gefllt
    for (i <- 1 to 10) {
      Broadcaster ! BroadcastMsg (i)      
    }

        
   // Die Datenlisten von ListCalculations werden auf Resultatslisten gemappt
   // Die Mappingregel wird von einem MapListProcessor definiert
   // Alle registrierten ListCalculations nutzen lp, um ihr Resultat zu berechnen.
   // Die Berechnung erfolgt sowohl nicht-nebenlufig (SimpleCalculation) als 
   // auch nebenlufig mit asynchronem Nachrichtenaustausch sowie mit Futures
   val lp = new MapListProcessorAdd5()
   Broadcaster ! BroadcastMsg (SimpleCalculation (lp )) 
   Broadcaster ! BroadcastMsg (AsyncCalculation (lp, 4) )
   Broadcaster ! BroadcastMsg (FutureCalculation (lp, 4) )
   
   

   // TODO Aufgabe 1 - Nutzen Sie einen weiteren MapListProcessor und wenden Sie diese auf die Testobjekte an  
   
    
    
  }

}

